
Global $i

#cs

Wordfast2TMX

read line
split by tab
get 5 and 7
write it

#ce

MsgBox (0, "Wordfast2tmx v0.1", "This script turns a Wordfast TM into a usable TMX file." & @CRLF & "It does not remove or convert entities and placeable tags," & @CRLF & "so the TMX will contain stuff like &'92; and &tA;.", 0)

; User selects the Wordfast file

$fileopendialog = FileOpenDialog ("Please select the Wordfast file", "", "All (*.*)|Text files (*.txt)")

; User indicates the WF file's encoding.  Ideally this would be done using
; a dropdown list but that requires more programming.

$encoding = InputBox ("Please enter encoding", "Please enter the Wordfast file's encoding (either ANSI or Unicode)", "ANSI")

$filesavedialog = FileSaveDialog ("Please indicate TMX file to save", "", "TMX files (*.tmx)", 16)

; Find out what the source and target language codes are

$SLcode = InputBox ("Please enter source language code", "Please enter the source language code in the form xx_XX", "en_US")
$TLcode = InputBox ("Please enter target language code", "Please enter the target language code in the form xx_XX", "af_ZA")

; Create the TMX file, and add a UTF8 BOM for luck.

$savedfileopen = FileOpen ($filesavedialog, 2)
$bin = StringToBinary("﻿")
FileWrite ($savedfileopen, $bin)
FileClose ($savedfileopen)

$saved2fileopen = FileOpen ($filesavedialog, 129)
FileWrite ($saved2fileopen, '<?xml version="1.0" encoding="UTF-8"?>' & @CRLF & '<!DOCTYPE tmx SYSTEM "tmx11.dtd">' & @CRLF & '<tmx version="1.1">' & @CRLF & '<header creationtool="some dumb script" creationtoolversion="alt.vampires.alpha.alpha.alpha" segtype="block" o-tmf="Wordfast 5.5 or similar" adminlang="EN-US" srclang="' & $SLcode & '" datatype="unknown">' & @CRLF & '</header>' & @CRLF & '<body>' & @CRLF)
FileClose ($saved2fileopen)

; The Select list converts a few incorrect case usages to the required case,
; and sets the read and write code numbers.  The write code number is not currently
; implemented, and the TMX file generated by this script is currently
; always UTF8.

Select
Case $encoding = "ANSI"
$rencoding = "0"
$wencoding = "1"
Case $encoding = "ansi"
$rencoding = "0"
$wencoding = "1"
Case $encoding = "Ansi"
$rencoding = "0"
$wencoding = "1"
Case $encoding = "Unicode"
$rencoding = "32"
$wencoding = "33"
Case $encoding = "unicode"
$rencoding = "32"
$wencoding = "33"
Case $encoding = "UNICODE"
$rencoding = "32"
$wencoding = "33"
EndSelect

; Open the file

$fileopen = FileOpen ($fileopendialog, $rencoding)

; Read entire file into variable

$fileread = FileRead ($fileopen)

; Split variable by line break

$line = StringSplit ($fileread, @CRLF, 1)

; Loop for number of items in array

For $i = 2 to $line[0]

; Split each line by tab

$tab = StringSplit ($line[$i], @TAB, 1)

; Kludge to skip writing if line is not conformant

$kludge1 = 0

If $tab[0] >= 7 Then

; Escape stuff

If StringInStr ($tab[5], '<') Then
$tab[5] = StringReplace ($tab[5], '<', '&lt;')
EndIf

If StringInStr ($tab[7], '<') Then
$tab[7] = StringReplace ($tab[7], '<', '&lt;')
EndIf

If StringInStr ($tab[5], '>') Then
$tab[5] = StringReplace ($tab[5], '>', '&gt;')
EndIf

If StringInStr ($tab[7], '>') Then
$tab[7] = StringReplace ($tab[7], '>', '&gt;')
EndIf

; Stupid TMX doen't like unknown entities, so let's make all &'s to be &amp;s

If StringInStr ($tab[5], "&") Then
$tab[5] = StringReplace ($tab[5], "&", "&amp;")
EndIf

If StringInStr ($tab[7], "&") Then
$tab[7] = StringReplace ($tab[7], "&", "&amp;")
EndIf


; Some weird control character causes Virtaal to choke, so let's remove it

If StringInStr ($tab[5], '') Then
$tab[5] = StringReplace ($tab[5], '', ' !!! ')
EndIf

If StringInStr ($tab[7], '') Then
$tab[7] = StringReplace ($tab[7], '', ' !!! ')
EndIf

; Open TMX file to save

$savefileopen = FileOpen ($filesavedialog, 129)

; Write TMX entry to end of TMX file

FileWrite ($savefileopen, @CRLF & '<tu>' & @CRLF & '<tuv lang="' & $SLcode & '">' & @CRLF & '<seg>' & $tab[5] & '</seg>' & @CRLF & '</tuv>' & @CRLF & '<tuv lang="' & $TLcode & '">' & @CRLF & '<seg>' & $tab[7] & '</seg>' & @CRLF & '</tuv>' & @CRLF & '</tu>' & @CRLF)

; Close the file again (although this never works)

FileClose ($savefileopen)

EndIf

Next

; Open TMX file to save

$savefileopenfinal = FileOpen ($filesavedialog, 129)

; Write TMX entry to end of TMX file

FileWrite ($savefileopenfinal, @CRLF & '</body>' & @CRLF & '</tmx>' & @CRLF)

; Close the file again (although this never works)

FileClose ($savefileopenfinal)

MsgBox (0, "Done!", "Done!", 0)